const express = require('express');
const io = require("socket.io-client");
//const socket = io('ws://tabu-server.willers.digital');
const socket = io('ws://localhost:3000');

function createRouter(db) {
    const router = express.Router();

    socket.on('Test:newRound', (data) => {
        console.log('NEW ROUND FROM: ', data)
    });

    socket.on('Test:endRound', (data) => {
        console.log('END ROUND FROM: ', data)
    });

    const isTrue = function(req, res) {
        res.header('Access-Control-Allow-Origin', "*").status(200).json({status: 'true'});
    };

    const isSession = function isSession(req, res, next) {
        const spielname = req.body.spielname;
        if (spielname.match(/^[0-9a-z]+$/) != null) {
            const sql = 'SELECT SessionName FROM Session WHERE SessionName = \''+spielname+'\';';
            console.log('isSession:' ,sql);
            db.query(
                sql,
                (error, results) => {
                    if (error) {
                        console.log(error);
                        return res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'error'});
                    } else {
                        if (results.length > 0) {
                            next();
                        } else {
                            return res.header('Access-Control-Allow-Origin', "*").status(200).json({status: 'false'});
                        }
                    }
                }
            );
        } else {
            return res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'error'});
        }
    };

    const getGamestatus = function(req, res) {
        const spielname = req.body.spielname;
        if (spielname.match(/^[0-9a-z]+$/) != null) {
            const sql = 'SELECT SessionID, Round, Red, Blue, RedTurn, ActiveExplainer, ActiveCard, isTabooh, lastPlay FROM Gamestatus WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")';
            console.log('getGamestatus: ',sql);
            db.query(
                sql,
                (error, results) => {
                    if (error) {
                        console.log(error);
                        res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
                    } else {
                        res.header('Access-Control-Allow-Origin', "*").status(200).json(
                            {
                                status: 'true',
                                round: results[0].Round,
                                sessionID: results[0].SessionID,
                                red: results[0].Red,
                                blue: results[0].Blue,
                                redTurn: results[0].RedTurn,
                                activeExplainer: results[0].ActiveExplainer,
                                activeCard: results[0].ActiveCard,
                                isTabooh: results[0].isTabooh,
                                lastPlay: results[0].lastPlay
                            }
                        );
                    }
                }
            );
        } else {
            res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'error'});
        }
    };

    const getActiveCard = function getActiveCard(req, res) {
        const spielname = req.body.spielname;
        if (spielname.match(/^[0-9a-z]+$/) != null) {
            const sql = 'SELECT ActiveCard FROM Gamestatus WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\");';
            console.log('getActiveCard: ', sql);
            db.query(
                sql,
                (error, results) => {
                    if (error) {
                        console.log(error);
                        res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'error'});
                    } else {
                        console.log(results);
                        res.header('Access-Control-Allow-Origin', "*").status(200).json({cardID: results[0].ActiveCard});
                    }
                })
        }
    };

    const addSession = function addSession(req, res) {
        const spielname = req.body.spielname;
        if (spielname.match(/^[0-9a-z]+$/) != null) {
            const sql = 'INSERT INTO Session (SessionName) VALUES (\"'+spielname+'\");';
            console.log('addSession1: ', sql);
            db.query(
                sql,
                error => {
                    if (error) {
                        console.error(error);
                        res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
                    } else {
                        //Init new Gamestatus
                        var redTurn = Math.random();
                        redTurn = Math.round(redTurn);
                        const sql = 'INSERT INTO Gamestatus (SessionID, Round, Red, Blue, RedTurn, ActiveExplainer, ActiveCard, isTabooh, lastPlay) VALUES ((SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\"), 0, 0, 0, '+redTurn+', 0, 0, 0, now());';
                        console.log('addSession2: ', sql);
                        db.query(
                            sql,
                            error => {
                                if (error) {
                                    console.error(error);
                                    res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
                                } else {
                                    res.header('Access-Control-Allow-Origin', "*").status(200).json({status: 'true'});
                                }
                            }
                        );
                    }
                }
            );
        } else {
            res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'error'});
        }
    };

    const session = function session(req, res) {
        const sql = 'SELECT * FROM Session';
        console.log('Session: ', sql);
        db.query(
            sql,
            (error, results) => {
                if (error) {
                    console.log(error);
                    res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'error'});
                } else {
                    res.header('Access-Control-Allow-Origin', "*").status(200).json(results);
                }
            }
        );
    };

    const getS2C = function getS2C(req, res) {
        const spielname = req.body.spielname;
        if (spielname.match(/^[0-9a-z]+$/) != null) {
            let card;
            const sql = 'SELECT Card.CardID, Solution, Tabu1, Tabu2, Tabu3, Tabu4, Tabu5 \n' +
                'FROM Card \n' +
                'WHERE Card.CardID NOT IN \n' +
                '(\n' +
                ' SELECT S2C.CardID\n' +
                ' FROM S2C\n' +
                ' WHERE S2C.CardID IS NOT NULL AND S2C.SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")\n' +
                ');';
            console.log('getS2C1: ', sql);
            db.query(
                sql,
                (error, results) => {
                    if (error) {
                        console.log(error);
                        res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
                    } else {
                        if (results.length > 0) {
                            let random = Math.random() * (results.length - 1);
                            random = Math.round(random);
                            card = results[random];

                            const sqlUpdate = 'UPDATE Gamestatus SET ActiveCard = ' + card.CardID + ' WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"' + spielname + '\")';
                            console.log('getS2C3: ', sql);
                            db.query(sqlUpdate);


                            const sqlInsert = 'INSERT INTO S2C (SessionID, CardID, Round, RedTurn, CardResultID, ActiveGame) VALUES ((SELECT SessionID FROM Session WHERE SessionName = \"' + spielname + '\"), ' + card.CardID + ', (SELECT Round FROM Gamestatus WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"' + spielname + '\")), (SELECT RedTurn FROM Gamestatus WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"' + spielname + '\")), 0, 1);';
                            console.log('getS2C2: ', sql);
                            db.query(sqlInsert);
                            res.header('Access-Control-Allow-Origin', "*").status(200).json(
                                {
                                    status: 'true',
                                    cardID: card.CardID,
                                    solution: card.Solution,
                                    tabu1: card.Tabu1,
                                    tabu2: card.Tabu2,
                                    tabu3: card.Tabu3,
                                    tabu4: card.Tabu4,
                                    tabu5: card.Tabu5,
                                }
                            );
                            socket.emit('newCard', {
                                'sessionName': spielname,
                                'cardID': card.CardID
                            })
                        } else {
                            res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'error alle Karten durch'});
                        }
                    }
                });
        } else {
            res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'error'});
        }
    };

    const isActiveExplainer = function isActiveExplainer(req, res, next) {
        const spielname = req.body.spielname;
        if (spielname.match(/^[0-9a-z]+$/) != null) {
            const sql = 'SELECT ActiveExplainer FROM Gamestatus WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")';
            console.log('isActiveExplainer: ',sql)
            db.query(
                sql,
                (error, results) => {
                     console.log('Result: ', results);
                    if (error) {
                        console.log(error);
                        res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false', reason: 'Round is active'});
                    } else {
                        const activeExplainer = JSON.parse(results[0].ActiveExplainer);
                        if (activeExplainer === 0) {
                            next();
                        } else {
                            res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false', reason: 'Round is active'});
                        }
                    }
                }
            );
        }
    };

    const newRound = function newRound(req, res) {
        const spielname = req.body.spielname;
        if (spielname.match(/^[0-9a-z]+$/) != null) {
            const sql = 'UPDATE Gamestatus SET ActiveExplainer = 1, lastPlay = now(), Round = Round + 1, isTabooh = 0 WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")';
            console.log('newRound: ', sql);
            db.query(
                sql,
                (error) => {
                    if (error) {
                        console.log(error);
                        res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
                    } else {
                        res.header('Access-Control-Allow-Origin', "*").status(200).json({status: 'true'});
                        socket.emit('newRound', {
                            sessionName: spielname,
                            isOpen: true
                        });
                        setTimeout(endRound, 60000, req);
                    }
                }
            );
        } else {
            res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false', reason: 'Already Active Game'});
        }
    };

    function endRound(req) {
        const spielname = req.body.spielname;
        if (spielname.match(/^[0-9a-z]+$/) != null) {
            const sql = 'UPDATE S2C SET CardResultID = 1 WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\") AND CardID = (SELECT ActiveCard FROM Gamestatus WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\"));' +
                'UPDATE Gamestatus SET RedTurn = (SELECT 1-Gamestatus.RedTurn FROM Gamestatus INNER JOIN Session ON Session.SessionID=Gamestatus.SessionID WHERE Session.SessionName = \"'+spielname+'\"),  ActiveExplainer = 0, ActiveCard =0 WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\");';
            console.log('endRound: ', sql);
            db.query(
                sql,
                (error) => {
                    if (error) {
                        console.log(error);
                        return
                        //res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
                    } else {
                        socket.emit('endRound', {
                            isOpen: true,
                            sessionName: spielname,
                        });
                        //res.header('Access-Control-Allow-Origin', "*").status(200).json({status: 'true'});
                    }
                }
            );
        } else {
            //res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
        }
    }

    const newGame = function newGame(req, res) {
        const spielname = req.body.spielname;
        if (spielname.match(/^[0-9a-z]+$/) != null) {
            const sql = 'UPDATE Gamestatus SET Round = 0, Red = 0, Blue = 0, RedTurn = '+Math.round(Math.random())+' WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\");' +
                'UPDATE S2C SET ActiveGame = 0 WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\");';
            console.log('newGame: ', sql);
            db.query(
                sql,
                (error) => {
                    if (error) {
                        console.log(error);
                        res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
                    } else {
                        res.header('Access-Control-Allow-Origin', "*").status(200).json({status: 'true'});
                        socket.emit('newGame', {
                            sessionName: spielname
                        });
                    }
                }
            );
        } else {
            res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
        }
    };

    const isPoint4Card = function isPoint4Card(req, res, next) {
        const spielname = req.body.spielname;
        const cardID = req.body.cardID;
        if (spielname.match(/^[0-9a-z]+$/) != null && !isNaN(cardID)) {
            const sql = 'SELECT ActiveCard FROM Gamestatus WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\");';
            console.log('isPoint4Card: ', sql);
            db.query(sql,
                (error, results) => {
                    if (error) {
                        console.log(error);
                        res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
                    } else {
                        let resultCardID = results[0].ActiveCard;
                        if (JSON.parse(resultCardID) === JSON.parse(cardID)) {
                            next();
                        } else {
                            res.header('Access-Control-Allow-Origin', "*").status(200).json({status: 'false'});
                        }
                    }
                }

            );
        } else {
            res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false body informal'});
        }
    };

    const canPressTabooh = function canPressTabooh(req, res, next) {
        const spielname = req.body.spielname;
        const sql = 'SELECT isTabooh FROM Gamestatus WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\");';
        console.log('canPressTabooh: ', sql);
        if (spielname.match(/^[0-9a-z]+$/) != null) {
            db.query(sql,
                (error, results) => {
                    if (error) {
                        console.log(error);
                        res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
                    } else {
                        let resultCardID = results[0].isTabooh;
                        if (JSON.parse(resultCardID) === 0) {
                            next();
                        } else {
                            res.header('Access-Control-Allow-Origin', "*").status(200).json({status: 'false'});
                        }
                    }
                });
        }
    };

    const setIsTaboohTo1 = function setIsTaboohTo1(req, res, next) {
        const spielname = req.body.spielname;
        const sql = 'UPDATE Gamestatus SET isTabooh = 1 WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")';
        console.log('setIsTaboohTo1:', sql);
        if (spielname.match(/^[0-9a-z]+$/) != null) {
            db.query(sql,
                (error) => {
                    if (error) {
                        console.log(error);
                        res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
                    } else {
                        socket.emit('canPressTabooh', {
                            canPressTabooh: false,
                            sessionName: spielname,
                        });
                        next();
                    }
                });
        }
    };

    const setIsTaboohTo0 = function setIsTaboohTo0(req, res) {
        const spielname = req.body.spielname;
        const sql = 'UPDATE Gamestatus SET isTabooh = 0 WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")';
        console.log('setIsTaboohTo0:', sql);
        if (spielname.match(/^[0-9a-z]+$/) != null) {
            db.query(sql,
                (error) => {
                    if (error) {
                        console.log(error);
                        res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
                    } else {
                        socket.emit('canPressTabooh', {
                            canPressTabooh: true,
                            sessionName: spielname,
                        });
                    }
                });
        }
    };

    const acceptRemovePoint = function acceptRemovePoint(req, res) {
        const spielname = req.body.spielname;
        const sql = 'SELECT Red, Blue FROM Gamestatus WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")';
        console.log('acceptRemovePoint:', sql);
        if (spielname.match(/^[0-9a-z]+$/) != null) {
            db.query(sql,
                (error, results) => {
                    if (error) {
                        console.log(error);
                        res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
                    } else {
                        res.header('Access-Control-Allow-Origin', "*").status(200).json(
                            {
                                status: 'true',
                                red: results[0].Red,
                                blue: results[0].Blue
                            }
                        );
                        setTimeout(setIsTaboohTo0, 1500, req, res);
                    }
                });
        }
    };

    const addPoint = function addPoint(req, res) {
        const spielname = req.body.spielname;
        const cardID = req.body.cardID;
        const team = req.body.team;
        if (spielname.match(/^[0-9a-z]+$/) != null && team.match(/^[0-9a-z]+$/) != null && !isNaN(cardID)) {
            if (team === 'red') {
                const sql = 'UPDATE Gamestatus SET Red = 1+(SELECT Red FROM Gamestatus WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")) WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\");' +
                    'UPDATE S2C SET CardResultID = 2 WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\") AND CardID = '+cardID+';';
                console.log('addPoint Red:', sql);
                db.query(
                    sql,
                    (error) => {
                        if (error) {
                            console.log(error);
                            res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
                        } else {
                            res.header('Access-Control-Allow-Origin', "*").status(200).json(
                                {
                                    status: 'true',
                                    red: JSON.parse(req.body.red)+1,
                                    blue: req.body.blue
                                }
                            );
                        }
                    }
                );
            } else if (team === 'blue') {
                const sql = 'UPDATE Gamestatus SET Blue = 1+(SELECT Blue FROM Gamestatus WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")) WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\");' +
                'UPDATE S2C SET CardResultID = 2 WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\") AND CardID = '+cardID+';';
                console.log('addPoint Blue:', sql);
                db.query(
                    sql,
                    (error) => {
                        if (error) {
                            console.log(error);
                            res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
                        } else {
                            res.header('Access-Control-Allow-Origin', "*").status(200).json(
                                {
                                    status: 'true',
                                    red: req.body.red,
                                    blue: JSON.parse(req.body.blue)+1
                                }
                            );
                        }
                    }
                );
            }
        } else {
            res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
        }
    };

    const removePoint = function removePoint(req, res, next) {
        const spielname = req.body.spielname;
        const cardID = req.body.cardID;
        const team = req.body.team;
        if (spielname.match(/^[0-9a-z]+$/) != null && team.match(/^[0-9a-z]+$/) != null && !isNaN(cardID)) {
            if (team === 'red') {
                const sql = 'UPDATE Gamestatus SET Red = -1+(SELECT Red FROM Gamestatus WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")) WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\");' +
                    'UPDATE S2C SET CardResultID = 4 WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\") AND CardID = '+cardID+';';
                console.log('removePoint Red: ', sql);
                db.query(
                    sql,
                    (error) => {
                        if (error) {
                            console.log(error);
                            res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
                        } else {
                            next()
                        }
                    }
                );
            } else if (team === 'blue') {
                const sql = 'UPDATE Gamestatus SET Blue = -1+(SELECT Blue FROM Gamestatus WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")) WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\");' +
                    'UPDATE S2C SET CardResultID = 4 WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\") AND CardID = '+cardID+';';
                console.log('removePoint Blue: ', sql);
                db.query(
                    sql,
                    (error) => {
                        if (error) {
                            console.log(error);
                            res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
                        } else {
                            next()
                        }
                    }
                );
            }
        } else {
            res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
        }
    };

    const skipCard = function skipCard(req, res) {
        const spielname = req.body.spielname;
        const cardID = req.body.cardID;
        if (spielname.match(/^[0-9a-z]+$/) != null && !isNaN(cardID)) {
            const sql = 'UPDATE S2C SET CardResultID = 3 WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\") AND CardID = '+cardID+';';
            console.log('skipCard: ', sql);
            db.query(
                sql,
                (error) => {
                    if (error) {
                        console.log(error);
                        res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
                    } else {
                        res.header('Access-Control-Allow-Origin', "*").status(200).json(
                            {
                                status: 'true',
                            }
                        );
                    }
                }
            );
        }
    };

    const getCard = function getCard(req, res) {
        const cardID = req.body.cardID;
        if (Number.isInteger(cardID)) {
            const sql = 'SELECT CardID, Solution, Tabu1, Tabu2, Tabu3, Tabu4, Tabu5 FROM Card WHERE CardID = \"'+cardID+'\"';
            console.log('getCard: ', sql);
            db.query(
                sql,
                (error, results) => {
                    if (error) {
                        console.log(error);
                        res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'error'});
                    } else {
                        if (results.length > 0) {
                            res.header('Access-Control-Allow-Origin', "*").status(200).json({
                                cardID: results[0].CardID,
                                solution: results[0].Solution,
                                tabu1: results[0].Tabu1,
                                tabu2: results[0].Tabu2,
                                tabu3: results[0].Tabu3,
                                tabu4: results[0].Tabu4,
                                tabu5: results[0].Tabu5
                            });
                        } else {
                            res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
                        }
                    }
                }
            );
        }
    };

    const getSessionHistory = function getSessionHistory(req, res) {
        const spielname = req.body.spielname;
        if (spielname.match(/^[0-9a-z]+$/)) {
            const sql = 'SELECT s.S2CID, c.Solution, c.Tabu1, c.Tabu2, c.Tabu3, c.Tabu4, c.Tabu5, s.Round, s.RedTurn, r.CardResultID, r.CardResultName\n' +
                'FROM S2C s LEFT JOIN Card c ON s.CardID = c.CardID LEFT JOIN CardResult r ON s.CardResultID = r.CardResultID\n' +
                'WHERE s.ActiveGame = 1 AND s.SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")' +
                'ORDER BY s.S2CID DESC';
            console.log('getSessionHistory: ', sql);
            db.query(
                sql,
                (error, results) => {
                    if (error) {
                        console.log(error);
                        res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'error'});
                    } else {
                        res.header('Access-Control-Allow-Origin', "*").status(200).send({status: true, history: results})
                    }
                })
        }
    };

    const historyChangePoint = function historyChangePoint(req, res, next) {
        const spielname = req.body.spielname;
        const s2cID = req.body.s2cID;
        const cardResultID = req.body.cardResultID;
        const redTurn = req.body.redTurn;
        const point = req.body.point;
        const timestamp = req.body.time;
        console.log(spielname, redTurn, point, s2cID, cardResultID);
        if (spielname.match(/^[0-9a-z]+$/) != null && !isNaN(redTurn) && !isNaN(s2cID) && !isNaN(cardResultID) && !isNaN(point) && -2 <= Number(point) <= 2) {
            //Get Team
            const redTurnNumber = Number(redTurn);
            let team = '';
            if (redTurnNumber === 0) {
                team = 'Blue'
            } else {
                team = 'Red'
            }
            //Create SQL
            const sql = 'UPDATE S2C SET CardResultID = '+ cardResultID + ' WHERE S2CID = '+s2cID+';' +
                'UPDATE Gamestatus SET ' + team +' = ' + point + ' +(SELECT ' + team + ' FROM Gamestatus WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")) WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\");';
            console.log('historyChangePoint: ', sql);
            db.query(
                sql,
                (error) => {
                    if (error) {
                        console.log(error);
                        res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
                    } else {
                        next();
                        socket.emit('historyChanged', {
                            sessionName: spielname,
                            time: timestamp
                        })
                    }
                }
            );
        } else {
            res.header('Access-Control-Allow-Origin', "*").status(500).json({status: 'false'});
        }

    };

    // the routes are defined here

    //Generate new Session
    router.post('/addSession', [addSession]);

    //Check if Session exist
    router.post('/isSession', [isSession, isTrue]);

    //Return all Sessions (Not neccesary)
    router.get('/Session', [session]);

    //Return GameStatus
    router.post('/getGamestatus', ([isSession, getGamestatus]));

    //Return S2C
    router.post('/getS2C', [getS2C]);

    //Start a new Round and lock the game positions
    router.post('/newRound', [isSession, isActiveExplainer, newRound]);

    //End a Round and unlock the game positions and invert RedTurn
    router.post('/endRound', [endRound]);

    //Starts a new Game and resets red and blue and chooses a random value for RedTurn
    router.post('/newGame', [isSession, isActiveExplainer, newGame]);

    //Add Point
    router.post('/addPoint', [isPoint4Card, addPoint]);

    //Remove Point
    router.post('/removePoint', [isPoint4Card, canPressTabooh, setIsTaboohTo1, removePoint, acceptRemovePoint]);

    //Skip Card
    router.post('/skipCard', [isPoint4Card, skipCard]);

    //Get ActiveCard
    router.post('/getActiveCard', [isSession, getActiveCard]);

    //Get Card
    router.post('/getCard', [getCard]);

    //Get Session History
    router.post('/getSessionHistory', [getSessionHistory]);

    //Change Point or Points in History
    router.post('/historyChangePoint', [historyChangePoint, getGamestatus]);

    return router;
}

module.exports = createRouter;
